package timing.ukulele.auth.security.service;

import org.springframework.security.core.userdetails.User;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.security.crypto.password.PasswordEncoder;
import timing.ukulele.auth.security.model.CustomGrantedAuthority;

public class TimingUserDetailService implements UserDetailsService {
    private final PasswordEncoder passwordEncoder;

    public TimingUserDetailService(PasswordEncoder passwordEncoder) {
        this.passwordEncoder = passwordEncoder;
    }

    @Override
    public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
        UserDetails user = User.withUsername("admin")
                .password(passwordEncoder.encode("123456"))
                .roles("admin", "normal")
                .authorities(new CustomGrantedAuthority("app"),new CustomGrantedAuthority("web"), new CustomGrantedAuthority("system"))
                .build();
        return user;
    }

    public UserDetails loadUserByMobile(String mobile) {
        UserDetails user = User.withUsername("admin")
                .password(passwordEncoder.encode("123456"))
                .roles("admin", "normal")
                .authorities(new CustomGrantedAuthority("app"),new CustomGrantedAuthority("web"), new CustomGrantedAuthority("system"))
                .build();
        return user;
    }
}
